/****************************************************************************
*	$Id: config.h 1.5 93/07/16 11:43:29 ROOT_DOS Exp $                       *
*	20 May 92	1.2		GT	Dial up stuff only.					      			 *
*	13 Jul 93	1.3		GT	Disable LZW.				          					 *
*							Disable SLIP.									                *
****************************************************************************/

/****************************************************************************
*                                                                           *
*	ATARI version by David Nash - dnash@chaos.demon.co.uk                    *
*                                                                           *
*	28.08.94 DFN - Remove Mailbox & RIP                                      *
*                                                                           *
****************************************************************************/

#ifndef	_CONFIG_H
#define	_CONFIG_H

/* Software options */
#undef	MAILBOX			/* Include SM0RGV mailbox server */
#define	NNTP			1	/* Netnews client */
#define	SERVERS		1	/* Include TCP servers */
#define	TRACE			1	/* Include packet tracing code */
#undef	RIP				/* Include RIP routing */
#define	HOPCHECK		1	/* IP path tracing command */
#define	DIALER		1	/* SLIP redial code */
#undef	NRS				/* NET/ROM async interface */
#undef	NETROM			/* NET/ROM network support */
#undef	LZW				/* LZW-compressed sockets */
#define	SLIP			1	/* Serial line IP on built-in ports */
#define 	PPP			1	/* Point-to-Point Protocol code */
#define 	VJCOMPRESS	1	/* Van Jacobson TCP compression for SLIP */
#define 	ATCMD      	1  /* Include timed 'at' execution */
#undef 	MULTITASK  	   /* Include Dos shell multi-tasker */
#define 	ALLCMD     	1  /* if undefined, exclude a bunch of commands */
#undef	ANSI				/* Emulate an ansi terminal */
#define 	DSERVER		1	/* Domain Name Server */
#define	FILTER		1	/* IP packet filtering */
#define	FILETRANS	1	/* X/Y/Zmodem file transfer */

/* Software tuning parameters */
#define	MTHRESH		8192	/* Default memory threshold */
#define	NROWS			25		/* Number of rows on screen */
#define	NIBUFS		5		/* Number of interrupt buffers */
#define	IBUFSIZE		2048	/* Size of interrupt buffers */
#define	NSESSIONS	10		/* Number of interactive clients */
#define	DEFNSOCK		40		/* Default number of sockets */

/* Hardware driver options */
#undef	ARCNET			/* ARCnet via PACKET driver */
#undef	PC_EC				/* 3-Com 3C501 Ethernet controller */
#undef	KISS				/* KISS TNC code */
#undef	HS					/* High speed (56kbps) modem driver */
#undef	HAPN				/* Hamilton Area Packet Network driver code */
#undef	EAGLE				/* Eagle card driver */
#undef	PI					/* PI card driver */
#undef	PACKET			/* FTP Software's Packet Driver interface */
#undef	PC100				/* PAC-COM PC-100 driver code */
#undef	APPLETALK		/* Appletalk interface (Macintosh) */
#undef	DRSI				/* DRSI PCPA slow-speed driver */
#undef	SCC				/* PE1CHL generic scc driver */
#define	ASY			1	/* Asynch driver code */
#undef	SLFP				/* SLFP packet driver class supported */

#if defined(NRS)
#undef	NETROM
#define	NETROM		1	/* NRS implies NETROM */
#endif

#if (defined(HS)||defined(NETROM)||defined(KISS)||defined(HAPN)||defined(EAGLE)||defined(PC100)||defined(PI))
#define	AX25		1	/* AX.25 subnet code */
#endif

#if (defined(ARCNET) || defined(SLFP))
#undef	PACKET
#define	PACKET		1	/* FTP Software's Packet Driver interface */
#endif

#if (defined(PC_EC) || defined(PACKET))
#define	ETHER	1		/* Generic Ethernet code */
#endif

#endif	/* _CONFIG_H */
