.TH QUARKOUTFILE 1 26.01.1994 "Uwe Ohse" "Tauschtools"
.SH NAME
quarkoutfile \- Konvertiert Outfiles von QUARK 1.x
.SH SYNOPSIS
quarkoutfile <eingehendes_outfile >konvertiertes_outfile
.PP
oder quarkoutfile -i eingang -o outfile
.PP 
oder beide Formen gemischt.
.SH BESCHREIBUNG
.I Quark 1.x 
(die heutige Version der Quark, im folgenden einfach nur 
.I Quark 
genannt, im Gegensatz zu 
.I Quark II
, der kommenden Version) 
Outfiles sind im grossen und ganzen zu denen der MAUS 
kompatibel. Die Datenbank der Quark, die noch aus der Zeit stammt, als die
Quark mit dem MausNet nichts zu tun hatte, verursacht leider mehr oder weniger 
geringfuegige Probleme, die hier mit den von quarkoutfile 
benutzen Methoden zu deren Beseitigung aufgezaehlt werden sollen:
.PP
Die Quark weiss nichts ueber die 
.I ">"-Zeilen (Kopfzeilen)
des MausTauschs. Sie werden in einfache Textzeilen umgewandelt. Die meisten
Frontends zeigen diese Zeilen nicht an, da sie diese Informationen aus dem
Header gewinnen. Daher stoert diese Angewohnheit der Quark den
Bildschirmaufbau.
.I quarkoutfile 
loest das Problem, indem es diese Zeilen entfernt (nachdem es ihnen 
einige Daten entnommen hat, die fuer die Beseitigung einiger anderer
Unschoenheiten wichtig sind).
.PP 
Die Quark kennt die
.I "I"-Zeilen (Original-ID, Fremdnetz-ID)
(die aus Fremdnetzen uebernommen werden)
nicht, sie gehen beim Netpoll verloren.
.I quarkoutfile 
restauriert diese Zeile aus den oben schon genannten Kopfzeilen. Zu diesem
Zweck werden die mit 
.I ':MId :' 
oder 
.I ': MId:' 
beginnenden Zeilen ausgewertet. 
.PP 
Ebenso kennt die Quark die 
.I "R"-Zeilen (Original-Referenz, Fremdnetz-Refenrenz)
(die aus Fremdnetzen uebernommen werden)
nicht. Deren Inhalt wird von 
.I quarkoutfile 
aus den mit
.I ':RId :' 
oder 
.I ': RId:' 
beginnenden Zeilen restauriert.

.PP 
Auch die 
.I "O"-Zeilen (Organisation, Box)
(die aus Fremdnetzen mitgeliefert werden)
kennt die Quark nicht. Deren Inhalt wird von 
.I quarkoutfile 
aus den mit 
.I ':Box :' 
oder 
.I ': Box:' 
beginnenden Zeilen restauriert.
.PP 
Als letzte Fremdnetz-Information stehen noch die
.I "N"-Zeilen (Realname)
aus. Auch diese kennt die Quark nicht.
.I quarkoutfile 
restauriert deren Inhalt aus den mit 
.I ':Name:' 
beginnenden Zeilen.
.PP 
Die Laenge der 
.I Absendernamen 
ist in der Quark auf 24 beschraenkt. Als Folge davon
erzeugt der Quarktausch gelegentlich Absender, auf die nicht 
geantwortet werden kann.
.I quarkoutfile
uebernimmt den echten Absendernamen aus den mit 
.I ':Von :'
oder 
.I ': Von:'
beginnenden Zeilen.
.PP
Als 
.I Messagedatum 
wird das Datum des Einsortierens in die Datenbank
der Quark benutzt. (Dies liegt weniger an der DB als daran, dass eine
ganze Menge Programmlogik davon abhaengt, dass die Nachrichten nach
Datum sortiert sind).
.I quarkoutfile 
entnimmt die echte Zeit des Schreibens aus den mit
.I ':Von :'
oder
.I ': Von:'
beginnenden Zeilen.
.PP
Der ITG (der Informationstext ueber Gruppen) frueherer Versionen der
Quark 1.5 und 1.6 fehlte Doppelpunkte vor den Zeilen, daher konnten
Frontends diese Datei nicht auswerten. 
.I quarkoutfile
beseitigt dieses Problem.
.PP
Noch ein Problem in der ITG der Quark war, dass am Ende der Gruppennamen
Leerzeichen standen. 
.I quarkoutfile 
beseitigt diese.
.PP
Das Logfile der Quark entspricht nicht hundertprozentig dem der MAUS,
so fehlt die Quittung fuer die Logfiles, und die :#-Zeile kommt 
verspaetet. 
.I quarkoutfile
schreibt die Quittung fuer das #CMD (:#CMD) und fuer die 
Infileendekennzeichnung vor die jeweils erste Kommandoquittung
oder vor die erste Infofile-CRC, und beseitigt gegebenenfalls die
normalerweise bei der Quark am Ende des Outfiles stehende :#-Zeile.
Es ist nur moeglich, ein :#CMD zu erzeugen, nicht aber soviele,
wie #CMD gesendet wurden. 
.SH NUTZEN
Ausser den aus dem oben geschriebenen offensichtlichen Vorteilen:
.IP - 
Der Einsatz von Int2Maus oder Use2Maus (Programme, die fuer 
eine echte Verkettung von aus Fremdnetzen stammenden Nachrichten
sorgen) wird moeglich.
.SH OPTIONEN
.IP -16
Das Outfile stammt aus einer Quark 1.6. Dieser Schalter ist 
wahrscheinlich ungefaehrlich bei Outfiles von Quark 1.5, und sollte
besser nicht benutzt werden, falls das Outfile aus einer Maus kam,
da dann die >-Zeilen (Kopfzeilen, eigentlich ueberfluessig) 
unnoetigerweise abgeschnitten werden.
.IP -i 
Name der auszulesenden Datei. Wenn diese Option nicht gegeben ist, wird
aus der Standardeingabe gelesen.
.IP -o
Name der Ausgabedatei. Wenn nicht angegeben, wird auf die Standardausgabe
geschrieben.
.IP -v
gibt die Versionsnummer auf der Standardfehlerausgabe aus. Das Programm
wird nicht beendet!
.IP -b
Puffergroesse in Kilobyte. Eine groessere Zahl auf 32 oder 64 
(entspricht 64 Kilobyte) ist nicht sinnvoll.
Es werden fuer ein- und ausgehende Daten
getrennte Puffer verwendet, so dass der Speicherbedarf des Programmes
um das doppelte der hier angegebenen Menge steigt.
Sollte nicht genuegend Speicher alloziert werden koennen, arbeitet das 
Programm trotzdem, wenn auch moeglicherweise erheblich langsamer.
.IP -K
Normalerweise wirft Quarkoutfile die Pseudoheader einfach weg. Wird diese
Option benutzt, werden sie als >-Zeilen (Kopfzeilen) weitergereicht. 
Kaum ein Frontend benutzt diese Zeilen, viele werfen sie einfach weg.
Dennoch, vielleicht nuetzt dies ja irgendwem. Ein mit dieser Option
erzeugtes Outfile ist 100%ig mauskompatibel.
.IP -T
Um die Pseudoheader in den Messageheader schreiben zu lassen, wie es
die Quark normalerweise tut, ist diese Option zu waehlen. Sie ist 
nuetzlich, wenn man am Kopf der Nachricht Absender und so weiter 
sehen will.
.IP -L
erzeugt lange IDs in der "#"- und "-"-Zeile, vorzugsweise durch Uebernahme
der "I"- und "R"-Zeilen. Diese Option ist fr den Einsatz durch Quark 2.x
gedacht und nicht fuer den Benutzertausch.
.IP -l
kopiert lange IDs in den "#"- und "-"-Zeilen in die "I"- und "R"-Zeilen
und traegt entsprechende kurze in die "#"- und "-"-Zeilen ein.
Diese Option ist fuer den Einsatz durch Quark 2.x
gedacht und nicht fuer den Benutzertausch.
.IP -0
Diese Option ist nur zusammen mit "-l" nutzbar und bewirkt, dass
Nachrichten, fr die keine kurze "#"-ID erzeugt werden kann, weggeworfen
werden. Das ist das, was ansonsten die Pollmaus damit tun wrde ...
Diese Option ist fuer den Einsatz durch Quark 2.x
gedacht und nicht fuer den Benutzertausch.
.IP -d 
Hier kann man angeben, auf wieviele Nachrichten ein Punkt auf 
dem Bildschirm geschrieben werden soll. Die Ausgabe erfolgt
normalerweise auf der Standardausgabe, wenn aber die Ausgabe der Daten auf
schon darauf erfolgt, werden die Punkte auf die Standardfehlerausgabe
geschrieben (anders gesagt: es passiert nichts schlimmes).
Wird diese Option nicht gegeben, wird keine Ausgabe gemacht.
.IP -F
Manche Frontends fragen die Versionsnummer der MAUS ab, die diese
ins Outfile schreibt. Mit dieser Option kann man die Versionsnummer,
die die Quark ins Outfile schreibt, aendern. Beispielsweise
durch "-F 7.94" (laesst das Frontend glauben, die Versionsnummer
der Box sei 7.94).
.IP -B
Und fuer den Fall, dass ein Frontend auch noch den Boxtyp abfragt,
kann man mit dieser Option den im Outfile eingetragenen Boxtyp aendern. 
Beispiel: "-B MAUS".
.IP -S
Angeblich mag ein Frontend keine langen Betreffs. Auch seinen Benutzern
kann geholfen werden: "-S 30" kuerzt den Betreff auf 30 Zeichen.
.IP -H
Einige Frontends, speziell die etwas aelteren Versionen, moegen den
HEAD-Block nicht. Mit dieser Option kann man ihn filtern.
.IP -U
Diese Option veranlasst Quarkoutfile, den Betreff zu entumlauten.
.SH NICHT BEHOBENE PROBLEME VON QUARK 1.x
.PP
Die Quark vor 1.5i weiss nichts ueber Distributionen und wirft sie einfach
weg.
.PP 
Dasselbe gilt fuer den Messagestatus.
.PP
Quark 1.x verkuerzt den Betreff der Nachrichten auf 28 Zeichen. 
Quarkoutfile kann dies nur teilweise wieder beheben.
.SH WARNUNG
Trotz ausfuehrlichen Tests koennen immer noch eine Menge Bugs im
Programm sein. 
.SH ENVIRONMENT
Quarkoutfile beachtet die folgenden Environmentvariablen:
.PP QUARKVERSION
Falls diese Variable gleich "16" oder "1.6" ist, wird angenommen, dass
das Programm an einer Quark 1.6 verwendet wird (wie Option "-16").
.PP COLUMNS
Gibt an, wieviele Zeichen auf eine Bildschirmzeile passen, und wird
nur genutzt, wenn die Option "-d" angegeben ist.
.SH BUGS
Zur Zeit keine bekannt.
.SH PORTIERUNGSHINWEISE
Der Programmcode enthaelt Umlaute, die fuer den Einsatz der Option
.I -U
(Betreff entumlauten) in den Zeichensatz des Systems umgewandelt 
werden muessen.
.SH PROGRAMMSTATUS
.I quarkoutfile 
wird unter der GNU General Public Licence verbreitet.
.PP
Das Programm ist im 
.I Betatest
und bleibt dies auch!
Wer es benutzt, sollte damit rechnen, dass alles Schlechte der 
Welt, inclusive verlorenen Outfiles, zerstoerten Frontend-Datenbanken
und Erdbeben, passieren kann. Der Autor uebernimmt dafuer keine
Verantwortung, bittet aber um sachdienliche Hinweise, wenn 
irgendwelche Probleme auftreten.
.SH AUSBLICK
Quark II, die kommende Version der Quark, wird die beschriebenen 
Probleme nicht mehr haben, da die Datenbank von Grund auf erneuert
wurde. Ohne jeden Zweifel wird sie natuerlich neue Probleme haben,
dafuer buergt schon der Programmierer des Quarktauschs.
.SH AUTHOR
Uwe Ohse (uwe@tirka.gun.de, "uwe ohse@me")

